#ifndef CONFIGFILE
#define CONFIGFILE

#include <iostream>
#include <fstream>
#include <sstream>
#include <string>
#include <map>
using namespace std;

template <class T>
inline std::string to_string (const T& t)
{
	std::stringstream ss;
	ss << t;
	return ss.str();
}

class ConfigFile
{
private:
	map<string, string> Settings;
	bool FileExists();
	void ReadSettings();
	void WriteDefault();
protected:
	string File;
	void setup();
	virtual string GetDefault()
	{
		return string("# No default set!");
	}
	virtual string GetFilename()
	{
		return string("Config.conf");
	}
public:
	ConfigFile(string Filename="")
	{
		File = Filename;
	}
	string GetValue(string Key);
	void AddValue(string Key, string Value);
};

#endif
